﻿Option Strict On
Option Explicit On

Public Class TextBoxEintrag
   Private Counter As Int32 = 0
   Private Runtime As Int32 = 300
   Private Interval As Int32 = 50
   Private Character As Char = Nothing
   Private Sub TextBox1_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TextBox1.KeyPress
      If Me.TextBox1.ReadOnly Then Return
      'If AscW(e.KeyChar) = Keys.Enter Then
      '  Code -- Code
      'End If

      'Um die wichtigsten Keys zu prüfen
      If Me.CheckKeys(e.KeyChar) Then
         Return
      End If
      Me.Counter = Me.Runtime
      Me.StartTimer(True)
      Me.Character = e.KeyChar
   End Sub
   Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
      Me.Counter -= Me.Interval
      If Me.Counter <= 0 Then
         Me.StartTimer(False)
         Return
      End If
      Me.SetLabel(True)
   End Sub
   Private Sub SetLabel(_set As Boolean)
      If _set Then
         Me.Label1.Text = Me.Character
         Me.Label2.Text = Me.TextBox1.Text
         Return
      End If
      Me.Label1.Text = String.Empty
      Me.Label2.Text = String.Empty
   End Sub
   Private Function CheckKeys(ch As Char) As Boolean
      Return Me.GetKeys().Contains(AscW(ch))
   End Function
   Private Function GetKeys() As Int32()
      Return [Enum].GetValues(GetType(Keys)).Cast(Of Keys).Where(Function(c) c < 33 AndAlso c >= 0).ToArray
   End Function
   Private Sub StartTimer(_start As Boolean)
      If _start Then
         Me.Timer1 = New Timer With {.Enabled = True, .Interval = Me.Interval}
         Me.Timer1.Start()
         Return
      End If
      Me.SetLabel(False)
      If Me.Timer1 IsNot Nothing Then
         Me.Timer1.Stop()
         Me.Timer1.Enabled = False
         Me.Timer1 = Nothing
      End If
   End Sub
   Public Sub New()
      MyBase.New
      Me.InitializeComponent()

      Me.Timer1.Enabled = False
      Me.Timer1 = Nothing
   End Sub
End Class